#if __STDC__ || defined(__cplusplus)
#define P_(s) s
#else
#define P_(s) ()
#endif

/* alias.c */
void add_alias P_((int type, char *name, char *stuff));
extern int word_count P_((char *str));
char *parse_inline P_((char *str, char *args, int *args_flag));
extern int parse_number P_((char **str));
char *MatchingBracket P_((char *string, char left, char right));
char *expand_alias P_((char *name, char *string, char *args, int *args_flag, char **more_text));
char *get_alias P_((int type, char *name, int *cnt, char **full_name));
char **match_alias P_((char *name, int *cnt, int type));
void delete_alias P_((int type, char *name));
void list_aliases P_((int type, char *name));
int mark_alias P_((char *name, int flag));
void execute_alias P_((char *alias_name, char *alias, char *args));
void save_aliases P_((FILE *fp, int do_all));
void alias P_((char *command, char *args, char *subargs));
char *function_left P_((unsigned char *input));
char *function_stripansi P_((unsigned char *input));
char *function_right P_((unsigned char *input));
char *function_mid P_((unsigned char *input));
char *function_rand P_((unsigned char *input));
char *function_srand P_((unsigned char *input));
char *function_time P_((unsigned char *input));
char *function_stime P_((unsigned char *input));
char *function_tdiff P_((unsigned char *input));
char *function_index P_((unsigned char *input));
char *function_rindex P_((unsigned char *input));
char *function_match P_((unsigned char *input));
int do_rmatch P_((char *strings, char *patterns));
char *function_rmatch P_((unsigned char *input));
char *function_userhost P_((unsigned char *input));
char *function_strip P_((unsigned char *input));
char *function_encode P_((unsigned char *input));
char *function_decode P_((unsigned char *input));
char *function_ischannel P_((unsigned char *input));
char *function_ischanop P_((unsigned char *input));
char *function_word P_((unsigned char *input));
char *function_winnum P_((unsigned char *input));
char *function_winnam P_((unsigned char *input));
char *function_connect P_((unsigned char *input));
char *function_listen P_((unsigned char *input));
char *function_toupper P_((unsigned char *input));
char *function_tolower P_((unsigned char *input));
char *function_curpos P_((unsigned char *input));
char *function_channels P_((unsigned char *input));
char *function_servers P_((unsigned char *input));
char *function_onchannel P_((unsigned char *input));
char *function_pid P_((unsigned char *input));
char *function_ppid P_((unsigned char *input));
char *function_chanusers P_((unsigned char *input));
char *function_strftime P_((unsigned char *input));
char *function_idle P_((unsigned char *input));
char *function_utime P_((unsigned char *input));
char *function_uptime P_((unsigned char *input));
char *function_tdiff2 P_((unsigned char *input));
char *function_eleet P_((unsigned char *input));
char *function_cool P_((unsigned char *input));
char *function_annoy P_((unsigned char *input));
char *function_cluster P_((unsigned char *input));
char *function_getkey P_((unsigned char *input));
char *function_open P_((unsigned char *input));
char *function_read P_((unsigned char *input));
char *function_eof P_((unsigned char *input));
char *function_close P_((unsigned char *input));
char *function_write P_((unsigned char *input));
char *function_rmdir P_((unsigned char *input));
char *function_rename P_((unsigned char *input));
char *function_unlink P_((unsigned char *input));
char *function_bcopy P_((unsigned char *input));
char *function_checkshit P_((unsigned char *input));
char *function_checkuser P_((unsigned char *input));
char *function_rot13 P_((unsigned char *input));
/* bot.c */
void prepare_bothost P_((WhoisStuff *stuff, char *nick, char *args));
void bot P_((char *command, char *args, char *subargs));
void save_bot P_((FILE *fp));
/* cdcc.c */
char *msgcdcc P_((char *from, char *to, char *args));
void cdcc P_((char *command, char *args, char *subargs));
char *do_bdcc P_((CtcpEntry *ctcp, char *from, char *to, char *args));
void dcc_show_queue P_((char *args, char *from, char *to));
FileList *find_lastqueue P_((void));
void dcc_sendfrom_queue P_((void));
void dcc_queue P_((char *nick, char *filename, char *description));
void dcc_sendpack P_((char *args, char *from, char *to));
void dcc_getpack P_((char *args, char *from, char *to));
void dcc_listpack P_((char *args, char *from, char *to));
void dcc_listp P_((char *args, char *from, char *to));
void add_desc P_((char *args, char *subargs));
void add_file P_((char *args, char *subargs));
void dcc_addpack P_((char *args, char *from, char *to));
void del_file P_((char *args, char *subargs));
void dcc_delpack P_((char *args, char *from, char *to));
void dcc_offer P_((char *args, char *from, char *to));
void dcc_notice P_((char *args, char *from, char *to));
void dcc_help P_((char *args, char *from, char *to));
void dcc_mhelp P_((char *args, char *from, char *to));
/* crypt.c */
char *is_crypted P_((char *nick));
void encrypt_cmd P_((char *command, char *args, char *subargs));
char *crypt_msg P_((char *str, char *key, int flag));
/* ctcp.c */
char *ctcp_quote_it P_((char *str, int len));
char *ctcp_unquote_it P_((char *str, int *len));
char *do_ctcp P_((char *from, char *to, char *str));
char *do_notice_ctcp P_((char *from, char *to, char *str));
int in_ctcp P_((void));
char *do_utc P_((CtcpEntry *ctcp, char *from, char *to, char *args));
void send_ctcp P_((char *type, char *to, char *datatag, char *format, ...));
void send_ctcp_reply P_((char *to, char *datatag, char *format, ...));
/* dcc.c */
int get_to_from P_((char *Type));
void dcc_show_active P_((char *args));
void dcc_set_quiet P_((char *args));
DCC_list *dcc_searchlist P_((char *name, char *user, int type, int flag, char *othername));
void dcc_erase P_((DCC_list *Element));
void set_dcc_bits P_((fd_set *rd, fd_set *wd));
void dcc_check P_((fd_set *rd, fd_set *wd));
void process_dcc P_((char *args));
char *dcc_raw_listen P_((int port));
char *dcc_raw_connect P_((char *host, u_short port));
int send_talk_control P_((DCC_list *Client, int MessageType));
void multisend P_((char *usern, char *filen));
void dcc_filesend P_((char *args));
void multiget P_((char *usern, char *filen));
void dcc_getfile P_((char *args));
void register_dcc_offer P_((char *user, char *type, char *description, char *address, char *port, char *size));
void dcc_message_transmit P_((char *user, char *text, int type, int flag));
void dcc_chat_transmit P_((char *user, char *text));
void dcc_list P_((char *args));
void dcc_glist P_((char *args));
void close_all_dcc P_((void));
/* debug.c */
int setdlevel P_((int level));
int getdlevel P_((void));
void debug P_((int level, char *format, ...));
/* edit.c */
void do_forward P_((char *command, char *args, char *subargs));
void do_oops P_((char *command, char *args, char *subargs));
void reconnect P_((char *command, char *args, char *subargs));
void do_invite P_((char *command, char *args, char *subargs));
void do_umode P_((char *command, char *args, char *subargs));
void do_getout P_((char *command, char *args, char *subargs));
void do_unscrew P_((char *command, char *args, char *subargs));
void do_4op P_((char *command, char *args, char *subargs));
void do_mynames P_((char *command, char *args, char *subargs));
void my_whois P_((char *command, char *args, char *subargs));
void do_unkey P_((char *command, char *args, char *subargs));
void do_repeat P_((char *command, char *args, char *subargs));
int check_wait_command P_((char *nick));
void my_echo P_((char *command, char *args, char *subargs));
void ison_now P_((WhoisStuff *notused, char *nicklist, char *notused2));
void query P_((char *command, char *args, char *subargs));
void send_text P_((char *org_nick, char *line, char *command));
void do_send_text P_((char *command, char *args, char *subargs));
void command_completion P_((int key, char *ptr));
void parse_line P_((char *name, char *org_line, char *args, int hist_flag, int append_flag));
void parse_command P_((char *line, int hist_flag, char *sub_args));
void load P_((char *command, char *args, char *subargs));
void forward_character P_((int key, char *ptr));
void backward_character P_((int key, char *ptr));
void backward_history P_((int key, char *ptr));
void forward_history P_((int key, char *ptr));
void toggle_insert_mode P_((int key, char *ptr));
void send_line P_((int key, char *ptr));
void meta4_char P_((int key, char *ptr));
void meta3_char P_((int key, char *ptr));
void meta2_char P_((int key, char *ptr));
void meta1_char P_((int key, char *ptr));
void quote_char P_((int key, char *ptr));
void type_text P_((int key, char *ptr));
void irc_clear_screen P_((int key, char *ptr));
void parse_text P_((int key, char *ptr));
void edit_char P_((int key));
extern void execute_timer P_((void));
void eval_inputlist P_((char *args, char *line));
/* exec.c */
void set_wait_process P_((int proccess));
int get_child_exit P_((int pid));
int check_wait_status P_((int wanted));
void check_process_limits P_((void));
void do_processes P_((fd_set *rd));
void set_process_bits P_((fd_set *rd));
void add_process_wait P_((int proc_index, char *cmd));
int text_to_process P_((int proc_index, char *text, int show));
int is_process_running P_((int proc_index));
int logical_to_index P_((char *logical));
int get_process_index P_((char **args));
int is_process P_((char *arg));
void execcmd P_((char *command, char *args, char *subargs));
void clean_up_processes P_((void));
void close_all_exec P_((void));
void exec_server_delete P_((int i));
/* file.c */
int directory_writeable P_((char *file));
int ruid_open P_((char *filename, int flags, int mode));
FILE *ruid_fopen P_((char *filename, char *mode));
int ruid_unlink P_((char *filename));
int ruid_system P_((char *command));
int ruid_stat P_((char *path, struct stat *buf));
/* flood.c */
int check_flooding P_((char *nick, int type, char *line));
/* funny.c */
void funny_match P_((char *stuff));
void set_funny_flags P_((int min, int max, int flags));
void funny_print_widelist P_((void));
void funny_list P_((char *from, char **ArgList));
void funny_namreply P_((char *from, char **Args));
void funny_mode P_((char *from, char **ArgList));
void update_user_mode P_((char *modes));
void reinstate_user_modes P_((void));
/* help.c */
void help P_((char *command, char *args, char *subargs));
/* history.c */
void set_history_file P_((char *file));
void set_history_size P_((int size));
void add_to_history P_((char *line));
char *get_from_history P_((int which));
void history P_((char *command, char *args, char *subargs));
char *do_history P_((char *com, char *rest));
/* hold.c */
void reset_hold P_((Window *win));
void add_to_hold_list P_((Window *window, char *str, int logged));
void remove_from_hold_list P_((Window *window));
void hold_mode P_((Window *window, int flag, int update_));
int hold_output P_((Window *window));
char *hold_queue P_((Window *window));
int hold_queue_logged P_((Window *window));
void toggle_stop_screen P_((unsigned char key, char *ptr));
/* hook.c */
int do_hook P_((int which, char *format, ...));
extern void remove_hook P_((int which, char *nick, int server, int sernum, int quiet));
void on P_((char *command, char *args, char *subargs));
void save_hooks P_((FILE *fp, int do_all));
/* if.c */
char *next_expr P_((char **args, char type));
void ifcmd P_((char *command, char *args, char *subargs));
void whilecmd P_((char *command, char *args, char *subargs));
void foreach_handler P_((char *command, char *args, char *subargs));
void foreach P_((char *command, char *args, char *subargs));
void fe P_((char *command, char *args, char *subargs));
void forcmd P_((char *command, char *args, char *subargs));
extern void fec P_((char *command, char *args, char *subargs));
/* ignore.c */
int is_ignored P_((char *nick, int type));
void ignore P_((char *command, char *args, char *subargs));
void set_highlight_char P_((char *s));
int ignore_combo P_((int flag1, int flag2));
int double_ignore P_((char *nick, char *userhost, int type));
/* input.c */
void cursor_to_input P_((void));
void update_input P_((int update_));
void refresh_inputline P_((int key, char *ptr));
void change_input_prompt P_((int direction));
void input_move_cursor P_((int dir));
void input_forward_word P_((int key, char *ptr));
void input_backward_word P_((int key, char *ptr));
void input_delete_character P_((int key, char *ptr));
void input_backspace P_((int key, char *ptr));
void input_beginning_of_line P_((int key, char *ptr));
void input_end_of_line P_((int key, char *ptr));
void input_delete_previous_word P_((int key, char *ptr));
void input_delete_next_word P_((int key, char *ptr));
void input_add_character P_((int key, char *ptr));
void set_input P_((char *str));
char *get_input P_((void));
void input_clear_to_eol P_((int key, char *ptr));
void input_clear_to_bol P_((int key, char *ptr));
void input_clear_line P_((int key, char *ptr));
void input_transpose_characters P_((int key, char *ptr));
void init_input P_((void));
void input_yank_cut_buffer P_((int key, char *ptr));
char *get_input_prompt P_((void));
void set_input_prompt P_((char *prompt));
char input_pause P_((char *msg));
/* irc.c */
void irc_exit P_((void));
void irc_quit P_((unsigned char key, char *ptr));
void display_bitchx P_((void));
int irc_io P_((char *prompt, void (*func)(unsigned char, char *), int use_input, int loop));
void main P_((int argc, char *argv[], char *envp[]));
/* ircaux.c */
void new_free P_((void *iptr));
void wait_new_free P_((char **ptr));
void really_free P_((int level));
char *new_realloc P_((char *ptr, int size));
char *new_malloc P_((int size));
void malloc_strcpy P_((char **ptr, char *src));
void malloc_strcat P_((char **ptr, char *src));
char *upper P_((char *str));
int connect_by_number P_((int service, char *host, int nonblocking));
char *next_arg P_((char *str, char **new_ptr));
char *new_next_arg P_((char *str, char **new_ptr));
int my_stricmp P_((char *str1, char *str2));
int my_strnicmp P_((char *str1, char *str2, int n));
void strmcpy P_((char *dest, char *src, int maxlen));
void strmcat P_((char *dest, char *src, int maxlen));
void strmcat_ue P_((char *dest, char *src, int maxlen));
extern int scanstr P_((char *source, char *str));
char *expand_twiddle P_((char *str));
char *check_nickname P_((char *nick));
char *sindex P_((char *string, char *group));
int is_number P_((char *str));
char *rfgets P_((char *buffer, int size, FILE *file));
char *path_search P_((char *name, char *path));
char *double_quote P_((char *str, char *stuff));
void new_stty P_((char *option));
FILE *zcat P_((char *name));
/* ircflush.c */
void death P_((void));
void main P_((int argc, char **argv));
/* ircio.c */
char *new_malloc P_((int size));
void new_free P_((char **ptr));
void main P_((int argc, char **argv));
/* ircsig.c */
/* keys.c */
void parsekeycmd P_((char *command, char *args, char *subargs));
void bindcmd P_((char *command, char *args, char *subargs));
void rbindcmd P_((char *command, char *args, char *subargs));
void (*get_send_line P_((void)))(unsigned char, char *);
void change_send_line P_((void (*func)(unsigned char, char *)));
void type P_((char *command, char *args, char *subargs));
void save_bindings P_((FILE *fp, int do_all));
/* lastlog.c */
char *bits_to_lastlog_level P_((int level));
int parse_lastlog_level P_((char *str));
void set_lastlog_level P_((char *str));
void set_lastlog_size P_((int size));
void lastlog P_((char *command, char *args, char *subargs));
int set_lastlog_msg_level P_((int level));
void add_to_lastlog P_((Window *window, char *line));
int islogged P_((Window *window));
int real_notify_level P_((void));
int real_lastlog_level P_((void));
void set_notify_level P_((char *str));
/* list.c */
void add_to_list_ext P_((List **list, List *add, int (*cmp_func)(List *, List *)));
void add_to_list P_((List **list, List *add));
List *find_in_list_ext P_((List **list, char *name, int wild, int (*cmp_func)(List *, char *)));
List *find_in_list P_((List **list, char *name, int wild));
List *remove_from_list_ext P_((List **list, char *name, int (*cmp_func)(List *, char *)));
List *remove_from_list P_((List **list, char *name));
List *removewild_from_list P_((List **list, char *name));
List *list_lookup_ext P_((List **list, char *name, int wild, int delete, int (*cmp_func)(List *, char *)));
List *list_lookup P_((List **list, char *name, int wild, int delete));
/* log.c */
FILE *do_log P_((int flag, char *logfile, FILE *fp));
void logger P_((int flag));
void set_log_file P_((char *filename));
void add_to_log P_((FILE *fp, char *line));
/* mail.c */
int check_mail_status P_((void));
char *check_mail P_((void));
/* menu.c */
void load_menu P_((char *FileName));
int ShowMenuByWindow P_((Window *window, int flags));
int ShowMenu P_((char *Name));
void set_menu P_((char *Value));
void enter_menu P_((unsigned char key, char *ptr));
void menu_previous P_((char *args));
void menu_submenu P_((char *args));
void menu_exit P_((char *args));
void menu_channels P_((char *args));
void menu_key P_((char key));
void menu_command P_((char *args));
/* misc.c */
void do_uptime P_((char *command, char *args, char *subargs));
void extern_write P_((char *command, char *args, char *subargs));
/* names.c */
void add_to_join_list P_((char *chan, int server, int winref));
void remove_from_join_list P_((char *chan, int server));
int get_win_from_join_list P_((char *chan, int server));
char *get_chan_from_join_list P_((int server));
int in_join_list P_((char *chan, int server));
void got_info P_((char *chan, int server, int type));
extern ChannelList *lookup_channel P_((char *channel, int server, int unlink));
void add_channel P_((char *channel, int server));
void add_to_channel P_((char *channel, char *nick, int server, int oper, int voice, char *userhost));
char *get_channel_mode P_((char *channel, int server));
void update_channel_mode P_((char *channel, int server, char *mode));
int is_channel_mode P_((char *channel, int mode, int server_index));
void remove_channel P_((char *channel, int server));
void remove_from_channel P_((char *channel, char *nick, int server));
void rename_nick P_((char *old_nick, char *new_nick, int server));
int is_on_channel P_((char *channel, int server, char *nick));
int is_chanop P_((char *channel, char *nick));
void list_channels P_((void));
void switch_channels P_((unsigned char key, char *ptr));
char *real_channel P_((void));
void change_server_channels P_((int old, int new));
void clear_channel_list P_((int server));
void reconnect_all_channels P_((int server));
char *channel_key P_((char *channel));
char *what_channel P_((char *nick, int server));
char *walk_channels P_((char *nick, int init, int server));
int get_channel_oper P_((char *channel, int server));
extern void set_channel_window P_((Window *window, char *channel, int server));
extern char *create_channel_list P_((Window *window));
extern void channel_server_delete P_((int server));
extern void remove_from_mode_list P_((char *channel, int server));
extern int chan_is_connected P_((char *channel, int server));
/* newio.c */
extern time_t dgets_timeout P_((int sec));
int dgets P_((char *str, int len, int des, char *specials));
int new_select P_((fd_set *rd, fd_set *wd, struct timeval *timeout));
void new_close P_((int des));
extern void set_socket_options P_((int s));
/* notice.c */
void parse_notice P_((char *from, char **Args));
void got_initial_version P_((char *line));
/* notify.c */
void show_notify_list P_((int all));
void notify P_((char *command, char *args, char *subargs));
void do_notify P_((void));
void notify_mark P_((char *nick, int flag, int doit));
void save_notify P_((FILE *fp));
void set_notify_handler P_((char *value));
/* numbers.c */
char *numeric_banner P_((void));
void display_msg P_((char *from, char **ArgList));
void numbered_command P_((char *from, int comm, char **ArgList));
/* output.c */
/* parse.c */
void fake P_((void));
int is_channel P_((char *to));
char *PasteArgs P_((char **Args, int StartPoint));
void beep_em P_((int beeps));
void whoreply P_((char *from, char **ArgList));
void parse_server P_((char *line));
void irc2_parse_server P_((char *line));
/* pluto.c */
int isme P_((char *nick));
void clear_link P_((struct server_split **serv1));
void add_server P_((struct server_split **serv1, char *channel, char *arg));
int find_server P_((struct server_split *serv1, char *channel));
void parse_364 P_((char *channel, char *args, char *subargs));
void parse_365 P_((char *channel, char *args, char *subargs));
void watch_split P_((void));
void show_links P_((char *channel, char *args, char *subargs));
void linklook P_((char *channel, char *arg, char *subargs));
void do_dirlastnotice P_((char *command, char *args, char *subargs));
void do_dirlastmsg P_((char *command, char *args, char *subargs));
void do_dump P_((char *command, char *args, char *subargs));
void LameKick P_((char *command, char *args, char *subargs));
void ChanWallOp P_((char *command, char *args, char *subargs));
void split_kill P_((char *path, char **who, char **who_uh, char **server, char **dead, char **reason));
void utimediff P_((long int s1, long int us1, long int s2, long int us2, long int *temp, long int *utemp));
void log_kill P_((char *nick, char *from, char *host, char *server, char *reason));
int logmsg P_((int rc, char *type, char *from, char *string, char *extra, int flag));
void msglogger P_((int flag));
void not_on_a_channel P_((void));
int are_you_opped P_((char *channel));
int you_is_opped P_((char *channel));
void you_not_opped P_((char *channel));
char *terminate P_((char *string, char *chars));
int freadln P_((FILE *stream, char *lin));
char *randreason P_((void));
char *get_reason P_((void));
char *do_nslookup P_((char *host));
void do_reconnect P_((char *newnick));
void do_newuser P_((char *newnick, char *newusername, char *ircname));
char *left P_((char *string, int i));
char *right P_((char *string, int num));
char *random_str P_((int min, int max));
char *get_token P_((char **src, char *token_sep));
char *my_next_arg P_((char **the_arg));
int numchar P_((char *string, int c));
char *my_stristr P_((char *s1, char *s2));
char *cluster P_((char *hostname));
void netfinger P_((char *name));
void com_unban P_((char *channel, char *arg));
void uh_notify P_((WhoisStuff *stuff, char *nick, char *args));
void userhost_nsl P_((WhoisStuff *stuff, char *nick, char *args));
void userhost_unban P_((WhoisStuff *stuff, char *nick, char *args));
void userhost_ban P_((WhoisStuff *stuff, char *nick, char *args));
void prepare_userhost P_((WhoisStuff *stuff, char *nick, char *args));
void userhost_ignore P_((WhoisStuff *stuff, char *nick, char *args));
void userhost_siteban P_((WhoisStuff *stuff, char *nick, char *args));
void nkill P_((char *command, char *args, char *subargs));
void hmode P_((char *command, char *args, char *subargs));
void reset P_((char *command, char *args, char *subargs));
void do_flood P_((char *command, char *args, char *subargs));
void cycle P_((char *command, char *args, char *subargs));
void tochanops P_((char *command, char *args, char *subargs));
void bomb P_((char *command, char *args, char *subargs));
void nslookup P_((char *command, char *args, char *subargs));
void newhost P_((char *command, char *args, char *subargs));
void newnick P_((char *command, char *args, char *subargs));
void newuser P_((char *command, char *args, char *subargs));
void start_finger P_((WhoisStuff *stuff, char *nick, char *args));
void finger P_((char *command, char *args, char *subargs));
void multkick P_((char *command, char *args, char *subargs));
void massdeop P_((char *command, char *args, char *subargs));
void doop P_((char *command, char *args, char *subargs));
void dodeop P_((char *command, char *args, char *subargs));
void massop P_((char *command, char *args, char *subargs));
void masskick P_((char *command, char *args, char *subargs));
void mknu P_((char *command, char *args, char *subargs));
void masskickban P_((char *command, char *args, char *subargs));
void masskickbanold P_((char *command, char *args, char *subargs));
void massban P_((char *command, char *args, char *subargs));
void unban P_((char *command, char *args, char *subargs));
void dokick P_((char *command, char *args, char *subargs));
void kickban P_((char *command, char *args, char *subargs));
void sitekickban P_((char *command, char *args, char *subargs));
void ban P_((char *command, char *args, char *subargs));
void do_ig P_((char *command, char *args, char *subargs));
void add_user P_((char *command, char *args, char *subargs));
void do_listshit P_((char *command, char *args, char *subargs));
void siteban P_((char *command, char *args, char *subargs));
void users P_((char *command, char *args, char *subargs));
void whokill P_((char *command, char *args, char *subargs));
void handle_masskill P_((char *nick));
void handle_tracekill P_((char *nick));
void tracekill P_((char *command, char *args, char *subargs));
void traceserv P_((char *command, char *args, char *subargs));
void add_to_a_list P_((char *thestring, int thetype, char *nick, int level, int autoop, int prot, char *channels, char *passwd));
void add_to_linked_list P_((NickList **listptr, char *string, char *nick, int level, int autoop, int prot, char *channels, char *passwd));
void showlist P_((NickList *listptr, char *listtype));
NickList *nickinlist P_((NickList *listptr, char *uh, char *niq));
void savelists P_((char *command, char *args, char *subargs));
char *convert P_((char *string));
int caps_fucknut P_((char *crap));
/* queue.c */
extern void queuecmd P_((char *cmd, char *args, char *subargs));
/* readlog.c */
void remove_log P_((char *command, char *args, char *subargs));
void readlog P_((char *command, char *args, char *subargs));
/* reg.c */
int wild_match P_((char *pattern, char *str));
/* scandir.c */
/* screen.c */
void add_wait_prompt P_((char *prompt, void (*func)(char *, char *), char *data, int type));
void set_current_screen P_((Screen *screen));
void window_redirect P_((char *who, int server));
int check_screen_redirect P_((char *nick));
void kill_screen P_((Screen *screen));
int is_main_screen P_((Screen *screen));
void scroll_window P_((Window *window));
int output_line P_((char *str, char **result, int startpos));
int rite P_((Window *window, char *str, int show, int redraw, int backscroll, int logged));
void cursor_not_in_display P_((void));
void cursor_in_display P_((void));
int is_cursor_in_display P_((void));
void redraw_resized P_((Window *window, ShrinkInfo Info, int AnchorTop));
ShrinkInfo resize_display P_((Window *window));
void recalculate_windows P_((void));
void clear_window P_((Window *window));
void clear_all_windows P_((int unhold));
void redraw_window P_((Window *window, int just_one));
void recalculate_window_positions P_((void));
void redraw_all_windows P_((void));
void add_to_screen P_((char *buffer));
void update_all_windows P_((void));
Window *new_window P_((void));
void close_all_screen P_((void));
Window *create_additional_screen P_((void));
void scrollback_forwards P_((unsigned char key, char *ptr));
void scrollback_backwards P_((unsigned char key, char *ptr));
void scrollback_end P_((unsigned char key, char *ptr));
void scrollback_start P_((unsigned char key, char *ptr));
void sig_refresh_screen P_((void));
/* server.c */
void close_server P_((int server_index, char *message));
void set_server_bits P_((fd_set *rd, fd_set *wd));
void do_server P_((fd_set *rd, fd_set *wd));
extern int find_in_server_list P_((char *server, int port));
int parse_server_index P_((char *str));
void add_to_server_list P_((char *server, int port, char *password, char *nick, int overwrite));
extern void remove_from_server_list P_((int i));
void parse_server_info P_((char *name, char **port, char **password, char **nick));
void build_server_list P_((char *servers));
int connect_to_server P_((char *server_name, int port, int c_server));
void get_connected P_((int server));
int read_server_file P_((void));
void display_server_list P_((void));
void MarkAllAway P_((char *command, char *message));
char *set_server_password P_((int server_index, char *password));
void server P_((char *command, char *args, char *subargs));
void flush_server P_((void));
void set_server_whois P_((int server_index, int value));
int get_server_whois P_((int server_index));
void set_server_2_6_2 P_((int server_index, int value));
int get_server_2_6_2 P_((int server_index));
void set_server_flag P_((int server_index, int flag, int value));
int get_server_flag P_((int server_index, int value));
void set_server_version P_((int server_index, int version));
int get_server_version P_((int server_index));
char *get_server_name P_((int server_index));
char *get_server_itsname P_((int server_index));
void set_server_itsname P_((int server_index, char *name));
int is_server_open P_((int server_index));
int is_server_connected P_((int server_index));
int get_server_port P_((int server_index));
char *get_server_nickname P_((int server_index));
WhoisQueue *get_server_qhead P_((int server_index));
WhoisStuff *get_server_whois_stuff P_((int server_index));
WhoisQueue *get_server_qtail P_((int server_index));
void set_server_qhead P_((int server_index, WhoisQueue *value));
void set_server_qtail P_((int server_index, WhoisQueue *value));
int get_server_operator P_((int server_index));
void set_server_operator P_((int server_index, int flag));
void set_server_nickname P_((int server_index, char *nick));
void set_server_motd P_((int server_index, int flag));
int get_server_motd P_((int server_index));
void server_is_connected P_((int server_index, int value));
void send_to_server P_((char *format, ...));
int connect_to_unix P_((int port, char *path));
extern void close_all_server P_((void));
extern char *create_server_list P_((void));
void disconnectcmd P_((char *command, char *args, char *subargs));
int find_server_group P_((char *group, int add));
char *find_server_group_name P_((int number));
/* stack.c */
void stackcmd P_((char *command, char *args, char *subargs));
/* status.c */
void set_alarm P_((char *str));
char *update_clock P_((int flag));
void reset_clock P_((char *unused));
void build_status P_((char *format));
void make_status P_((Window *window));
/* term.c */
int term_echo P_((int flag));
void term_putchar P_((unsigned char c));
int term_puts P_((char *str, int len));
int putchar_x P_((int c));
void term_flush P_((void));
void term_reset P_((void));
void term_cont P_((void));
void term_pause P_((unsigned char key, char *ptr));
void term_init P_((void));
int term_resize P_((void));
void term_space_erase P_((int x));
extern void copy_window_size P_((int *lines, int *columns));
extern int term_eight_bit P_((void));
extern void set_term_eight_bit P_((int value));
/* translat.c */
void enter_digraph P_((unsigned char key, char *ptr));
unsigned char get_digraph P_((unsigned char c1));
void set_translation P_((char *tablename));
void digraph P_((char *command, char *args, char *subargs));
void save_digraphs P_((FILE *fp));
/* vars.c */
void init_variables P_((void));
int do_boolean P_((char *str, int *value));
void set_var_value P_((int var_index, char *value));
void set_variable P_((char *command, char *args, char *subargs));
char *get_string_var P_((int var));
int get_int_var P_((int var));
void set_string_var P_((int var, char *string));
void set_int_var P_((int var, unsigned int value));
void save_variables P_((FILE *fp, int do_all));
char *make_string_var P_((char *var_name));
int charset_size P_((void));
void save_set P_((FILE *fp));
void double_status_line P_((int value));
/* whois.c */
void set_beep_on_msg P_((char *str));
void clean_whois_queue P_((void));
void ison_returned P_((char *from, char **ArgList));
void userhost_returned P_((char *from, char **ArgList));
void whois_name P_((char *from, char **ArgList));
void whowas_name P_((char *from, char **ArgList));
void whois_channels P_((char *from, char **ArgList));
void whois_server P_((char *from, char **ArgList));
void whois_oper P_((char *from, char **ArgList));
void whois_lastcom P_((char *from, char **ArgList));
void whois_chop P_((char *from, char **ArgList));
void end_of_whois P_((char *from, char **ArgList));
void no_such_nickname P_((char *from, char **ArgList));
void user_is_away P_((char *from, char **ArgList));
void whois_ignore_msgs P_((WhoisStuff *stuff, char *nick, char *text));
void whois_nickname P_((WhoisStuff *stuff, char *nick, char *text));
void whois_ignore_notices P_((WhoisStuff *stuff, char *nick, char *text));
void whois_ignore_invites P_((WhoisStuff *stuff, char *nick, char *text));
void whois_ignore_walls P_((WhoisStuff *stuff, char *nick, char *text));
void convert_to_whois P_((void));
void ison_notify P_((WhoisStuff *unused, char *AskedFor, char *AreOn));
void whois_notify P_((WhoisStuff *stuff, char *nick, char *text));
void whois_new_wallops P_((WhoisStuff *stuff, char *nick, char *text));
void add_to_whois_queue P_((char *nick, void (*func)(WhoisStuff *, char *, char *), char *format, ...));
void add_to_userhost_queue P_((char *nick, void (*func)(WhoisStuff *, char *, char *), char *format, ...));
void add_ison_to_whois P_((char *nick, void (*func)(WhoisStuff *, char *, char *)));
extern void userhost_cmd_returned P_((WhoisStuff *stuff, char *nick, char *text));
/* window.c */
Window *traverse_all_windows P_((int *flag));
void add_window_to_server_group P_((Window *window, char *group));
void set_scroll_lines P_((int size));
void set_scroll P_((int value));
void reset_line_cnt P_((int value));
void set_continued_line P_((char *value));
void erase_display P_((Window *window));
extern void add_to_invisible_list P_((Window *window));
void save_message_from P_((void));
void restore_message_from P_((void));
void message_from P_((char *who, int level));
int message_from_level P_((int level));
Window *get_window_by_refnum P_((u_int refnum));
void clear_window_by_refnum P_((u_int refnum));
void set_level_by_refnum P_((u_int refnum, int level));
void set_prompt_by_refnum P_((u_int refnum, char *prompt));
void message_to P_((u_int refnum));
void set_current_window P_((Window *window));
void swap_last_window P_((unsigned char key, char *ptr));
void next_window P_((unsigned char key, char *ptr));
void swap_next_window P_((unsigned char key, char *ptr));
void previous_window P_((unsigned char key, char *ptr));
void swap_previous_window P_((unsigned char key, char *ptr));
void back_window P_((unsigned char key, char *ptr));
extern Window *add_to_window_list P_((Window *new));
void window_check_servers P_((void));
void window_restore_server P_((int server));
void delete_window P_((Window *window));
void window_kill_swap P_((void));
int unhold_windows P_((void));
void update_window_status P_((Window *window, int refresh));
void redraw_all_status P_((void));
void update_all_status P_((void));
void status_update P_((int flag));
int is_current_channel P_((char *channel, int server, int delete));
extern int is_bound P_((char *channel, int server));
int get_window_server P_((unsigned int refnum));
void set_window_server P_((int refnum, int server, int misc));
char *set_channel_by_refnum P_((unsigned int refnum, char *channel));
char *get_channel_by_refnum P_((u_int refnum));
unsigned int current_refnum P_((void));
char *query_nick P_((void));
char *get_prompt_by_refnum P_((u_int refnum));
char *get_target_by_refnum P_((u_int refnum));
void set_query_nick P_((char *nick));
Window *get_window_by_name P_((char *name));
void window P_((char *command, char *args, char *subargs));
int number_of_windows P_((void));
void unstop_all_windows P_((unsigned char key, char *ptr));
void set_underline_video P_((int value));
void window_get_connected P_((Window *window, char *arg, int narg, int preserve, char *args));
/* wserv.c */
void main P_((int argc, char **argv));
void got_sigwinch P_((void));

#undef P_
