/*
 *   CDE created userlist functions.
 *   Copyright Colten Edwards 04/10/96
 *
 */
 
#include <sys/stat.h>
#include "irc.h"
#include "server.h"
#include "edit.h"
#include "crypt.h"
#include "vars.h"
#include "ircaux.h"
#include "lastlog.h"
#include "window.h"
#include "screen.h"
#include "whois.h"
#include "hook.h"
#include "input.h"
#include "ignore.h"
#include "keys.h"
#include "names.h"
#include "alias.h"
#include "history.h"
#include "funny.h"
#include "ctcp.h"
#include "dcc.h"
#include "translat.h"
#include "output.h"
#include "exec.h"
#include "notify.h"
#include "numbers.h"
#include "status.h"
#include "list.h"
#include "struct.h"
#include "timer.h"
#include "pluto.h"
#include "bot.h"
#include "userlist.h"


/*
 *  Shit levels
 *  1 no opz
 *  2 Auto Kick
 *  3 Auto Ban Kick
 *  4 perm ban. all times.
 *
 *  User levels
 *  25 ctcp invite and whoami
 *  50 ops, chops and unban
 *  90 no Kick/Dop flood checking
 *
 *  Auto-op levels
 *  0 auto-op off
 *  1 timed autoop
 *  2 instant op
 *
 *  Protection levels
 *  1 Reop if de-oped
 *  2 De-op offender
 *  3 Kick  offender
 *  4 KickBan offender
 */

#define SHITLIST_ADD 11
#define SHITLIST_REMOVE 12
#define USERLIST_ADD 13
#define USERLIST_REMOVE 14
#define USERLIST_MOD 15

int user_count = 0;
int shit_count = 0;
extern char *FromUserHost;
extern char *awaymsg;

NickList *user_list;
NickList *shitlist_list;
extern NickList *Bot_list;
extern AJoinList *ajoin_list;

extern void save_idle _((FILE *output));



void prepare_userhost(stuff, nick, args)
WhoisStuff *stuff;
char *nick, *args;
{
	char listbuf[BIG_BUFFER_SIZE+1];
	char *uh;
	int thetype = 0, i;
	int level = 0, autoop = 0, prot = 0, shit = 0;
	char *channels = NULL, *passwd = NULL, *p = NULL;
	ChannelList *chan; NickList *Nick;
	
        if (!stuff || !stuff->nick || !nick || !strcmp(stuff->user, "<UNKNOWN>") || my_stricmp(stuff->nick, nick))
        {
                say("No match for user %s", nick);
                return;
        }

	thetype = atoi(args);

	uh = stuff->user;
	if (*uh == '~' )
		uh++;
	if (*uh == '#')
		uh++;

	if (!(thetype % 2))
	    sprintf(listbuf, "*%s@%s", uh, stuff->host);
	else 
	{
		sprintf(listbuf, "*%s@%s", uh, cluster(stuff->host));
		p = next_arg(args, &args);
		p = next_arg(args, &args);
		level = atoi(p);
		p = next_arg(args, &args);
		autoop = atoi(p);
		p = next_arg(args, &args);
		prot = atoi(p);
		p = next_arg(args, &args);
		shit = atoi(p);
		if (strchr(args, ' ')) {
			p = next_arg(args, &args);
			malloc_strcpy(&channels, p);
			malloc_strcpy(&passwd, args);
		}else malloc_strcpy(&channels, args);
	}
	add_to_a_list(listbuf, thetype, stuff->nick, level, autoop, prot, channels, passwd, shit);
	if (thetype == USERLIST_ADD)
	{
		send_to_server("NOTICE %s :You have been added to my Userlist with a %d level", nick, level);
		send_to_server("NOTICE %s :you will %s auto-op'd", nick, autoop ? "be": "not be");
		send_to_server("NOTICE %s :you are %sprotected", nick, prot ? "": "not ");
	}
	for (i = 0; i < number_of_servers; i++)
	{
		if (!(chan = server_list[i].chan_list))
			continue;

		if ((Nick = (NickList *)find_in_list((List **)&chan->nicks, stuff->nick, 0)))
		{
			if (channels && (wild_match(channels, chan->channel) || wild_match(chan->channel, channels)))
			{
				Nick->userlevel = level;
				Nick->autoop = autoop;
				Nick->prot = prot;
			}
		}
	}
	if (channels) new_free(&channels); if (passwd) new_free(&passwd);
}

void add_user(char *command, char *args, char *subargs) 
{
	char *nick, *ptr;
	int level = 40, autoop = 0, prot = 0;
	char *passwd = NULL;
	char *channels = NULL;
	char *p = NULL; char * bang; char *temp = NULL;
	int type = USERLIST_ADD;
	
	if (command && *command && (my_stricmp(command,"UNUSER") == 0))
		type = USERLIST_REMOVE; 

	if (args && *args)
	{

		nick = next_arg(args, &args);
		if (!nick || !*nick) {
			return;
		}
		ptr = next_arg(args, &args);
		if (!ptr || !*ptr) {
			bitchsay("Need a channel for AddUser");
			return;
		}
		malloc_strcpy(&channels, ptr);

		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			level = atoi(ptr);
	
		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			autoop = atoi(ptr);

		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			prot = atoi(ptr);

		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			malloc_strcpy(&passwd, ptr);

		if ((bang = strchr(nick, '!')) && strchr(nick, '@'))
		{
			malloc_strcpy(&temp, nick);
			p = temp;
			bang = strchr(temp, '!');
			*bang++ = '\0';
			add_to_a_list(bang, type, p, level, autoop, prot, channels, passwd, 0);
			new_free(&p);
		}
		else
			if (passwd)
				add_to_userhost_queue(nick, prepare_userhost, "%d %d %d %d 0 %s %s", type, level, autoop, prot, channels, passwd);
			else
				add_to_userhost_queue(nick, prepare_userhost, "%d %d %d %d 0 %s", type, level, autoop, prot, channels);
	} else
		bitchsay("%s <nick or filter> <channel filter> <level> <aop> [<prot_level>] [<password>]", (command && *command)? command: "AddUser");
}


void add_shit(char *command, char *args, char *subargs) 
{
	char *nick, *ptr;
	int level = 1;
	char *reason = NULL;
	char *channels = NULL;
	char *p = NULL; char * bang; char *temp = NULL;

	int type = SHITLIST_ADD;
	
	if (command && *command && (my_stricmp(command, "UNSHIT")==0))
		type = SHITLIST_REMOVE;
	if (args && *args)
	{

		nick = next_arg(args, &args);
		if (!nick || !*nick) {
			return;
		}
		ptr = next_arg(args, &args);
		if (!ptr || !*ptr) {
			bitchsay("Need a channel for %s",command ? "UnShit": "AddShit");
			return;
		}
		malloc_strcpy(&channels, ptr);

		ptr = next_arg(args, &args);
		if (ptr && *ptr)
			level = atoi(ptr);

		if (args && *args)
			malloc_strcpy(&reason, args);
		else
			malloc_strcpy(&reason, "ShitListz");


		if ((bang = strchr(nick, '!')) && strchr(nick, '@'))
		{
			malloc_strcpy(&temp, nick);
			p = temp;
			bang = strchr(temp, '!');
			*bang++ = '\0';
			add_to_a_list(bang, type, p, 0, 0, 0, channels, reason, level);
			new_free(&p);
		}
		else
			add_to_userhost_queue(nick, prepare_userhost, "%d %d %d %d %d %s %s", type, 0, 0, 0, level, channels, reason);
		new_free(&reason);
	} else
		bitchsay("%s <nick or filter> <channel filter> <level> <reason>",(command && *command) ? command: "AddShit");
}

void add_to_a_list(thestring, thetype, nick, level, autoop, prot, channels, passwd, shitlevel)
char *thestring;
int thetype;
char *nick;
int level;
int autoop;
int prot;
char *channels;
char *passwd;
int shitlevel;
{
	NickList **TheList;
	NickList *to_remove = NULL;
	char which[16];

	switch (thetype)
	{
		case SHITLIST_ADD:
		case SHITLIST_REMOVE:
			TheList = &shitlist_list;
			strcpy(which, "Shit");
			break;
		case USERLIST_ADD:
		case USERLIST_REMOVE:
		case USERLIST_MOD:
			TheList = &user_list;
			strcpy(which, "User");
			break;
		default:
			bitchsay("Error!! Something FUCKED UP somewhere, thetype was unknown in add_to_a_list(%d)", thetype);
			return;
	}
	if (!(thetype % 2))
	{
		
		if ((to_remove = (NickList *)removewild_from_list((List **)TheList, nick)) != NULL) 
		{
			if (wild_match(to_remove->host, thestring) || wild_match(thestring, to_remove->host))
			{
				(thetype == USERLIST_ADD) ? user_count-- : shit_count--;
				new_free(&to_remove->host);
				new_free(&to_remove->nick);
				new_free(&to_remove->passwd);
				new_free(&to_remove->channels);
				new_free((char **)&to_remove);
				bitchsay("Deleting %s!%s from %s list", nick, thestring, which);
			} 
			else
			{
				add_to_list((List **)&user_list, (List *)to_remove);
				bitchsay("Didnt find %s!%s on %s list", nick, thestring, which);
			}
		} 
		else
			bitchsay("Didnt find %s on %s list", thestring, which);
	}
	else
	{
		if (nickinlist(*TheList, nick, thestring)==NULL)
		{
			if (thetype == USERLIST_ADD) 
				user_count++;
			else if (thetype == SHITLIST_ADD)
				shit_count++;
			add_to_linked_list(TheList, thestring, nick, level, autoop, prot, channels, passwd, shitlevel);
			if ((thetype == USERLIST_ADD) || (thetype == SHITLIST_ADD))
				bitchsay("Adding %s!%s to %s list", nick, thestring, which);
			else
				bitchsay("Modified %s!%s on %s list", nick, thestring, which);
		} else
			bitchsay ("%s!%s already on my %s list", nick,thestring, which);
	}
}

void add_to_linked_list(NickList **listptr, char *string, char *nick, 
			int level, int autoop, int prot, char *channels, 
			char *passwd, int shitlevel)
{
	NickList *newptr;
	
	newptr = (NickList *)new_malloc(sizeof(NickList));
	memset(newptr, 0, sizeof(NickList));
	malloc_strcpy(&newptr->host,string);
	if (nick)
		malloc_strcpy(&newptr->nick, nick);
	if (passwd)
		malloc_strcpy(&newptr->passwd, passwd);
	if (channels)
		malloc_strcpy(&newptr->channels, channels);
	newptr->userlevel = level;
	newptr->autoop = autoop;
	newptr->prot = prot;
	newptr->shitlisted = shitlevel;
	add_to_list((List **)listptr, (List *)newptr);
}

void showuserlist(char *command, char *args, char *subargs)
{
	NickList *tmp = user_list;
	int first = 0;
	if (!tmp)
	{
		bitchsay("No entries in User list");
		return;
	}
	while (tmp)
	{
		if (do_hook(USERLIST_LIST, "%d %d %d %s %s %s %s", tmp->userlevel, tmp->autoop, tmp->prot,tmp->nick,tmp->host,tmp->channels,tmp->passwd?tmp->passwd:""))
		{
			if (!first)
				put_it("level aop prot  nick       passwd     host                      channels");           
			first++;
			put_it(" %-03d   %-04d %-03d %-10s %-10s %-25s %s", 
				tmp->userlevel, tmp->autoop, tmp->prot, 
				tmp->nick, tmp->passwd?tmp->passwd:"<none>", 
				tmp->host, tmp->channels);
		}
		tmp = tmp->next;
	}
	if (first)
		bitchsay("End of User list");
}

void showshitlist(char *command, char *args, char *subargs)
{
	NickList *tmp = shitlist_list;
	int first = 0;
	if (!tmp)
	{
		bitchsay("No entries in Shit list");
		return;
	}
	while (tmp)
	{
		if (do_hook(SHITLIST_LIST, "%d %s %s %s %s %s %s", tmp->shitlisted, tmp->nick,tmp->channels, tmp->host, tmp->passwd?tmp->passwd:"<none>", "", ""))
		{
			if (!first)
				put_it("level nick       channels    host                      reason");
			put_it(" %-03d  %-10s %-11s %-25s %s", tmp->shitlisted,
					  tmp->nick, tmp->channels, tmp->host, 
					  tmp->passwd?tmp->passwd:"<No Reason>"); 
			first++;
		}
		tmp = tmp->next;
	}
	if (first)
		bitchsay("%d entries in Shit List",shit_count);
}

void set_user_info(char *command, char *args, char *subargs)
{

}

int check_channel_match(char *tmp, char *channel)
{
	char *p, *q, *chan = NULL;
	int match = 0;
	if (!tmp || !channel)
		return 0;
	if ((strchr(tmp, ',')))
	{
		malloc_strcpy(&chan, tmp);
		p = q = chan;
		while(chan && (p = strchr(chan, ',')))
		{
			*p = '\0';
			if ((match = wild_match(chan, channel)))
				break;
			chan = ++p;
		}
		if (!match)
			match = wild_match(chan, channel);
		new_free(&q);
	} 
	else
		match = wild_match(tmp, channel);
	return match;
}

NickList *nickinlist(NickList *listptr, char *niq, char *uh)
{
	char *theuh;
	NickList *thisptr;

	thisptr = listptr;
	if (!uh || !niq)
		return NULL;
	theuh = (char *) new_malloc(strlen(niq)+strlen(uh)+4);
	sprintf(theuh, "*%s", uh);
	while (thisptr)
	{
		if (!thisptr->host)
			continue;
		if (wild_match(theuh, thisptr->host) || wild_match(thisptr->host, theuh)) {
			new_free(&theuh);
			return(thisptr);
		}
		thisptr = thisptr->next;
	}
	new_free(&theuh);
	return NULL;
}

int find_user_level(char *from, char *host, char *channel)
{
NickList * tmp = user_list;
	if (!tmp)
		return 0;
	tmp = (NickList *) nickinlist(user_list, from, host);
	if (!tmp)
		return 0;
	if (check_channel_match(tmp->channels, channel))
		return tmp->userlevel;
	return 0;
}

int find_shit_level(char *from, char *host, char *channel)
{
NickList * tmp = shitlist_list;
	if (!shitlist_list)
		return 0;
	tmp = (NickList *) nickinlist(shitlist_list, from, host);
	if (!tmp)
		return 0;
	if (check_channel_match(tmp->channels, channel))
		return tmp->shitlisted;
	return 0;
}

void reload_save(char *command, char *args, char *subargs)
{
char *p = NULL;
char *buffer = NULL;
	if (get_string_var(CTOOLZ_DIR_VAR))
	{
		malloc_sprintf(&buffer, "%s", get_string_var(CTOOLZ_DIR_VAR));
		p = expand_twiddle(buffer);
		if (access(p, F_OK) != 0)
		{
			bitchsay("Created directory %s", p);
			mkdir(p, S_IWUSR|S_IRUSR);
		}
		new_free(&p);
		malloc_sprintf(&buffer, "%s/%s.sav", get_string_var(CTOOLZ_DIR_VAR), version);
	}
	else
		malloc_sprintf(&buffer, "~/%s.sav", version);
	p = expand_twiddle(buffer);
	load(empty_string, p, empty_string); /*CDE XXX p */
	new_free(&buffer);
	new_free(&p);
}

void savelists(char *command, char *args, char *subargs)
{
	char thefile[BIG_BUFFER_SIZE+1];
	char *p = NULL;
	FILE *outfile;
	NickList *listptr;
	AJoinList *ajoin;

	int count = 0;
	sprintf(thefile, "%s/%s.sav", get_string_var(CTOOLZ_DIR_VAR), version);
	p = expand_twiddle(thefile);
	outfile = fopen(p, "w");
	if (!outfile)
	{
		bitchsay("Cannot open file %s for saving!", thefile);
		new_free(&p);
		return;
	}
	if (do_hook(SAVEFILEPRE_LIST, "%s %s", thefile, p)) 
		bitchsay("Saving All Your Settings to %s", thefile);

        listptr = user_list;
	if (listptr)
		fprintf(outfile, "# %s UserList\n", version);
	count = 0;
        while(listptr)
        {
                fprintf(outfile, "ADDUSER %s!%s %s %d %d %d %s\n", listptr->nick, listptr->host, listptr->channels, listptr->userlevel, listptr->autoop, listptr->prot, listptr->passwd? listptr->passwd : "");
                listptr = listptr->next;
		count ++;
        }
	if (do_hook(SAVEFILE_LIST, "UserList %d", count)) 
	        bitchsay("Saved %d UserList entries", count);

	count = 0;
        listptr = shitlist_list;
	if (listptr)
		fprintf(outfile, "# %s ShitList\n", version);
        while(listptr)
        {
                fprintf(outfile, "ADDSHIT %s!%s %s %d %s\n", listptr->nick, listptr->host, listptr->channels, listptr->shitlisted, listptr->passwd? listptr->passwd : "");
                listptr = listptr->next;
		count ++;
        }
	if (do_hook(SAVEFILE_LIST, "ShitList %d", count)) 
	        bitchsay("Saved %d ShitList entries", count);

        ajoin = ajoin_list;
	if (ajoin)
		fprintf(outfile, "# %s Auto-Join List\n", version);
	count = 0;
        while (ajoin)
        {
         	if (ajoin->ajoin_list == 1) /* actual auto-join entry */
         	{
	                fprintf(outfile, "AJOIN %s\n", ajoin->name ? ajoin->name: "");
			count ++;
		}
       	        ajoin = ajoin->next;
        }
	if (do_hook(SAVEFILE_LIST, "AutoJoin %d", count)) 
	        bitchsay("Saved %d AutoJoin entries", count);

	save_bot(outfile);
	save_notify(outfile);
	save_idle(outfile);
	save_variables(outfile, 1);

	if (awaymsg)
		fprintf(outfile, "ENV AWAYMSG %s\n", awaymsg);
	if (do_hook(SAVEFILEPOST_LIST, "%s %s", thefile, p))
		bitchsay("Done Saving to file %s", thefile);
	
	fclose(outfile);
	new_free(&p);
}

int real_check_auto _((void *arg))
{
	char *nick, *host, *channel;
	char *p = (char *)arg;
	char *args = (char *)arg;
	
	channel = next_arg(args, &args);
	nick = next_arg(args, &args);
	host = next_arg(args, &args);
	
	if (channel && *channel && nick && *nick && host && *host)
	{
		check_auto(channel, nick, host);
	}
	
	new_free(&p);
	return 0;
}

int delay_check_auto _((char *channel))
{
	ChannelList *chan = NULL;
	NickList *possible = NULL;
	char *buffer;
	
	if (!channel || !*channel)
		return -1;
		
	if ((chan = lookup_channel(channel, from_server, CHAN_NOUNLINK)) == NULL)	
		return -1;

	possible = chan->nicks;
			
	for (; possible; possible = possible->next)
	{
		if (nickinlist(shitlist_list, possible->nick, possible->host) ||
		   nickinlist(user_list, possible->nick, possible->host))
		{
			buffer = NULL;
			malloc_sprintf(&buffer, "%s %s %s", channel, possible->nick, possible->host);
			add_timer(-1, 3, real_check_auto, buffer, NULL);
		}
	}
	return 0;
}

int delay_opz _((void *arg))
{
char * args = (char *)arg;
char * from = NULL;
char * channel = NULL;	
char *p = (char *) arg; /* original args unmodified  so we can free them */

	channel = next_arg(args, &args);
	from = next_arg(args, &args);
	if (is_chanop(channel, from) == 0 && is_on_channel(channel, from_server, from)) 
	{
		send_to_server("MODE %s +o %s", channel, from); 
		send_to_server("NOTICE %s :You have been delay Auto-op'd", from);
	}
	new_free(&p);
	return 0;
}

void check_auto(char *channel, char *nick, char *host)
{
NickList *shitptr = NULL;
NickList *userptr = NULL;
NickList *botptr = NULL;
ChannelList *chan_ptr;

	if (!channel || !*channel || !are_you_opped(channel) || !nick || !host)
		return;
	
	shitptr = nickinlist(shitlist_list, nick, host);
	userptr = nickinlist(user_list, nick, host);
	botptr = nickinlist(Bot_list, nick, host);
	chan_ptr = (ChannelList *) find_in_list((List **)&(server_list[from_server].chan_list), channel, 0);		

	if (userptr && !check_channel_match(userptr->channels, channel))
		userptr = NULL;
	if (botptr && !check_channel_match(botptr->channels, channel))
		botptr = NULL;
	if (shitptr && !check_channel_match(shitptr->channels, channel))
		shitptr = NULL;
		
	if (cget_int_var(SHITLIST_VAR, channel) && (shitptr != NULL) && (botptr == NULL) && (userptr == NULL))
	{
		char *theshit;
		theshit = get_string_var(SHITLIST_REASON_VAR);
		
		if (shitptr->userlevel > 10)
			return;
		shitptr->userlevel++;
		switch(shitptr->shitlisted)
		{
		
			case 0:
				return;
				break;
			case 1:/* never give opz */
				send_to_server("MODE %s -o %s", channel, nick);
				break;				
			case 2: /* Auto Kick  offender */
				send_to_server("KICK %s %s :%s", channel,
					nick, (shitptr->passwd && *shitptr->passwd) ? shitptr->passwd : theshit);
				break;
			case 3: /* kick ban the offender */
			case 4:	/* perm ban on offender */
				send_to_server("MODE %s -o+b %s %s!%s", channel, nick, nick, shitptr->host);
				send_to_server("KICK %s %s :%s", channel,
					nick, (shitptr->passwd && *shitptr->passwd) ? shitptr->passwd : theshit);
			default:
				break;
		}
		return;
	} 

	if (get_int_var(AOP_VAR) && cget_int_var(USERLIST_VAR, channel) && userptr != NULL) 
	{	
		char *buffer = NULL;
		switch (userptr->autoop)
		{
			case 1:
				malloc_sprintf(&buffer, "%s %s", channel, nick);
				if (is_chanop(channel, nick) == 0)
					add_timer(-1, 10, delay_opz, buffer, NULL);
				break;
			case 2:
				malloc_sprintf(&buffer, " MODE %s +o %s", channel, nick);
				if (is_chanop(channel, nick) == 0)
					send_to_server(buffer+1);
				new_free(&buffer);
			case 0:
			default:
				break;
		}
		return;
	}
}

void check_hack(char *nick, ChannelList *channel, NickList *ThisNick, char *from)
{
NickList *userptr = NULL;
NickList *botptr = NULL;
int	flag;

	if (from && !strchr(from, '.'))
		return;
	if (!channel || !are_you_opped(channel->channel) || !nick || !ThisNick || wild_match(nick, get_server_nickname(from_server)))
		return;
	if (!(flag = cget_int_var(HACKING_CVAR, channel->channel)))
		return;
	if (ThisNick->sent_deop && (time(NULL) - ThisNick->sent_deop_time < 10))
		return;
	userptr = nickinlist(user_list, nick, ThisNick->host);
	botptr = nickinlist(Bot_list, nick, ThisNick->host);
	
	if ( ((userptr == NULL) && (botptr == NULL)) || 
	     (( (userptr && !check_channel_match(userptr->channels, channel->channel)) || 
	     (botptr && !check_channel_match(botptr->channels, channel->channel)) ) )) 
	{
		switch(flag)
		{
			case 1:
			case 3:
				if (is_chanop(channel->channel, nick))
					send_to_server("MODE %s -o %s", channel->channel, nick);
				ThisNick->sent_deop++;
				ThisNick->sent_deop_time = time(NULL);
			case 2:
				if (flag != 1)
					bitchsay("NetHack detected on %s by %s!%s", channel->channel, nick, ThisNick->host); 
			case 0:
			default:
				break;
		}
	}
}

/*
 *  Protection levels
 *  1 Reop if de-oped
 *  2 De-op offender
 *  3 Kick  offender
 *  4 KickBan offender
 */
int check_prot(char *from, char *person)
{
NickList *tmp;
char *channel = NULL;

	if ((channel = get_channel_by_refnum(0)) == NULL || !from || !*from)
		return 0;

	if ((tmp = (NickList *)find_in_list((List **) &user_list, person, 1)))
	{
		if (!check_channel_match(tmp->channels, channel))
			return 0;
		switch(tmp->prot)
		{
			case 1:
			{
				if (!tmp->sent_reop)
				{
					send_to_server("MODE %s +o %s", channel, tmp->nick);
					tmp->sent_reop++;
					tmp->sent_reop_time = time(NULL);
				}
				break;
			}
			case 2:
			{
				send_to_server("MODE %s -o %s", channel, from);
				tmp->sent_deop++;
				tmp->sent_deop_time = time(NULL);
				break;
			}
			case 4:
			{
				send_to_server("MODE %s -o+b %s", channel, from);
			}
			case 3:
			{
				send_to_server("KICK %s %s :Protected User", channel, from);
				break;
			}
			default:
				break;
		}
		return 1;
	}
	return 0;
}

void change_user(char *command, char *args, char *subargs)
{
int comm = 0;
char *user, *what;
	if (!my_stricmp(command, "CHGLEVEL"))
		comm = 1;
	else if (!my_stricmp(command, "CHGPROT"))
		comm = 2;
	else if (!my_stricmp(command, "CHGCHAN"))
		comm = 3;
	else if (!my_stricmp(command, "CHGAUTOOP"))
		comm = 4;
	if (comm && (user = next_arg(args, &args)) && (what = next_arg(args, &args)))
	{
		NickList *ThisNick;
		int prot, level, autoop;
		char *channels = NULL;
		char *passwd = NULL;
		
		if (!(ThisNick = (NickList *)remove_from_list((List **)&user_list, user)))
		{
			bitchsay("Nick %s was not found", user);
			return;
		}	
		prot = ThisNick->prot;
		level = ThisNick->userlevel;
		autoop = ThisNick->autoop;
		channels = ThisNick->channels;
		passwd = ThisNick->passwd;					

		switch(comm)
		{
			case 1:
				level = atoi(what);
				break;
			case 2:
				prot = atoi(what);
				break;
			case 3:
				ThisNick->channels = NULL;
				malloc_strcpy(&channels, what);
				break;
			case 4:
				autoop = atoi(what);
				break;
			default:
				break;
		}
		if (passwd)
			add_to_userhost_queue(ThisNick->nick, prepare_userhost, "%d %d %d %d 0 %s %s", USERLIST_MOD, level, autoop, prot, channels,passwd);
		else
			add_to_userhost_queue(ThisNick->nick, prepare_userhost, "%d %d %d %d 0 %s", USERLIST_MOD, level, autoop, prot, channels);
		new_free(&ThisNick->nick);
		new_free(&ThisNick->host);
		new_free(&ThisNick->channels);
		new_free(&ThisNick->passwd);
		new_free((char **)&ThisNick);
	}		
	else
		bitchsay("%s: nick what", command);

	return;
}
